//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "edit.h"
//---------------------------------------------------------------------------
#pragma link "qrextra"
#pragma link "qrabout"
#pragma resource "*.dfm"
TfrmEditor *frmEditor;
//---------------------------------------------------------------------------
__fastcall TfrmEditor::TfrmEditor(TComponent* Owner)
	: TForm(Owner)
{
}
boolean __fastcall TfrmEditor::AskAndSave()
{
  String Filename;
  int Answer;
  unsigned int mbFlags;

  // Build our MessageBox flags
  mbFlags = MB_YESNOCANCEL + MB_ICONINFORMATION + MB_DEFBUTTON1 + MB_APPLMODAL;

  if (QREditor->Filename == "") {
    Filename = "(untitled)";
  }
  else {
    Filename = QREditor->Filename;
  }

  Answer = MessageBox(Handle, Filename.c_str(), "Save this report?", mbFlags);

  if (Answer == IDYES)
    QREditor->SaveReport();

  return (Answer != IDCANCEL);
}
void __fastcall TfrmEditor::SetMenuItems()
{
  SaveReport->Enabled = QREditor->Editing;
  SaveReportAs->Enabled = QREditor->Editing;
  CloseFile->Enabled = QREditor->Editing;
  PreviewReport->Enabled = QREditor->Editing;
  PrintReport->Enabled = QREditor->Editing;
  ReportLayout->Enabled = QREditor->Editing;
  DataSetup->Enabled = QREditor->Editing;
  Caption = "QREditor demo";
  if (QREditor->Editing) {
    if (QREditor->Filename != "") {
      Caption = Caption + " - " + QREditor->Filename;
    }
    else {
      Caption = Caption + " - (untitled)";
    }
  }
}

//---------------------------------------------------------------------------
void __fastcall TfrmEditor::miNewClick(TObject *Sender)
{
  if (QREditor->Editing) {
    if (AskAndSave()) {
      QREditor->NewReport();
    }
  }
  else
    QREditor->NewReport();

  SetMenuItems();
}
//---------------------------------------------------------------------------
void __fastcall TfrmEditor::Open1Click(TObject *Sender)
{
  if (QREditor->Editing) {
    if (AskAndSave()) {
      QREditor->OpenReport();
    }
  }
  else
    QREditor->OpenReport();
  SetMenuItems();
}
//---------------------------------------------------------------------------
void __fastcall TfrmEditor::SaveReportClick(TObject *Sender)
{
  QREditor->SaveReport();
}
//---------------------------------------------------------------------------
void __fastcall TfrmEditor::SaveReportAsClick(TObject *Sender)
{
  String OldFilename;

  OldFilename = QREditor->Filename;

  QREditor->Filename = "";

  QREditor->SaveReport();

  if (QREditor->Filename == "")
    QREditor->Filename = OldFilename;

  SetMenuItems();
}
//---------------------------------------------------------------------------
void __fastcall TfrmEditor::CloseFileClick(TObject *Sender)
{
  if (AskAndSave())
    QREditor->CloseReport();
  SetMenuItems();
}
//---------------------------------------------------------------------------
void __fastcall TfrmEditor::PreviewReportClick(TObject *Sender)
{
  QREditor->Report->Preview();
}
//---------------------------------------------------------------------------
void __fastcall TfrmEditor::PrintReportClick(TObject *Sender)
{
  QREditor->Report->Print();
}
//---------------------------------------------------------------------------
void __fastcall TfrmEditor::Exit1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TfrmEditor::FormCreate(TObject *Sender)
{
  SetMenuItems();
}
//---------------------------------------------------------------------------
void __fastcall TfrmEditor::AboutQuickreport1Click(TObject *Sender)
{
  TQRAboutBox* QRAboutBox;

  try
  {
    Application->CreateForm(__classid(TQRAboutBox), &QRAboutBox);
    QRAboutBox->ShowModal();
    QRAboutBox->Free();
  }
  catch (Exception &exception)
  {
    Application->ShowException(&exception);
  }
}
//---------------------------------------------------------------------------
